Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Types.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Types.h	(revision 112)
@@ -10,4 +10,5 @@
 
 #include "Behavioural/include/Types.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo {
@@ -58,29 +59,29 @@
     _nb_inst (nb_inst)
     {
-      _val            = new Tcontrol_t         [_nb_inst];
-      _context_id     = new Tcontext_t         [_nb_inst];
-      _depth          = new Tdepth_t           [_nb_inst];
-      _type           = new Ttype_t            [_nb_inst];
-      _operation      = new Toperation_t       [_nb_inst];
-      _no_execute     = new Tcontrol_t         [_nb_inst];
-      _is_delay_slot  = new Tcontrol_t         [_nb_inst];
+      ALLOC1(_val            ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_context_id     ,Tcontext_t         ,_nb_inst);
+      ALLOC1(_depth          ,Tdepth_t           ,_nb_inst);
+      ALLOC1(_type           ,Ttype_t            ,_nb_inst);
+      ALLOC1(_operation      ,Toperation_t       ,_nb_inst);
+      ALLOC1(_no_execute     ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_is_delay_slot  ,Tcontrol_t         ,_nb_inst);
 #ifdef DEBUG
-      _address        = new Tgeneral_data_t    [_nb_inst];
+      ALLOC1(_address        ,Tgeneral_data_t    ,_nb_inst);
 #endif
-      _address_next   = new Tgeneral_data_t    [_nb_inst];
-      _has_immediat   = new Tcontrol_t         [_nb_inst];
-      _immediat       = new Tgeneral_data_t    [_nb_inst];
-      _read_ra        = new Tcontrol_t         [_nb_inst];
-      _num_reg_ra     = new Tgeneral_address_t [_nb_inst];
-      _read_rb        = new Tcontrol_t         [_nb_inst];
-      _num_reg_rb     = new Tgeneral_address_t [_nb_inst];
-      _read_rc        = new Tcontrol_t         [_nb_inst];
-      _num_reg_rc     = new Tspecial_address_t [_nb_inst];
-      _write_rd       = new Tcontrol_t         [_nb_inst];
-      _num_reg_rd     = new Tgeneral_address_t [_nb_inst];
-      _write_re       = new Tcontrol_t         [_nb_inst];
-      _num_reg_re     = new Tspecial_address_t [_nb_inst];
-      _exception_use  = new Texception_t       [_nb_inst];
-      _exception      = new Texception_t       [_nb_inst];
+      ALLOC1(_address_next   ,Tgeneral_data_t    ,_nb_inst);
+      ALLOC1(_has_immediat   ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_immediat       ,Tgeneral_data_t    ,_nb_inst);
+      ALLOC1(_read_ra        ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_num_reg_ra     ,Tgeneral_address_t ,_nb_inst);
+      ALLOC1(_read_rb        ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_num_reg_rb     ,Tgeneral_address_t ,_nb_inst);
+      ALLOC1(_read_rc        ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_num_reg_rc     ,Tspecial_address_t ,_nb_inst);
+      ALLOC1(_write_rd       ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_num_reg_rd     ,Tgeneral_address_t ,_nb_inst);
+      ALLOC1(_write_re       ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_num_reg_re     ,Tspecial_address_t ,_nb_inst);
+      ALLOC1(_exception_use  ,Texception_t       ,_nb_inst);
+      ALLOC1(_exception      ,Texception_t       ,_nb_inst);
 
       for (uint32_t i=0; i<_nb_inst; i++)
@@ -90,29 +91,29 @@
   public : ~decod_queue_entry_t (void)
     {
-      delete [] _val            ;
-      delete [] _context_id     ;
-      delete [] _depth          ;
-      delete [] _type           ;
-      delete [] _operation      ;
-      delete [] _no_execute     ;
-      delete [] _is_delay_slot  ;
+      DELETE1(_val            ,_nb_inst);
+      DELETE1(_context_id     ,_nb_inst);
+      DELETE1(_depth          ,_nb_inst);
+      DELETE1(_type           ,_nb_inst);
+      DELETE1(_operation      ,_nb_inst);
+      DELETE1(_no_execute     ,_nb_inst);
+      DELETE1(_is_delay_slot  ,_nb_inst);
 #ifdef DEBUG
-      delete [] _address        ;
+      DELETE1(_address        ,_nb_inst);
 #endif
-      delete [] _address_next   ;
-      delete [] _has_immediat   ;
-      delete [] _immediat       ;
-      delete [] _read_ra        ;
-      delete [] _num_reg_ra     ;
-      delete [] _read_rb        ;
-      delete [] _num_reg_rb     ;
-      delete [] _read_rc        ;
-      delete [] _num_reg_rc     ;
-      delete [] _write_rd       ;
-      delete [] _num_reg_rd     ;
-      delete [] _write_re       ;
-      delete [] _num_reg_re     ;
-      delete [] _exception_use  ;
-      delete [] _exception      ;
+      DELETE1(_address_next   ,_nb_inst);
+      DELETE1(_has_immediat   ,_nb_inst);
+      DELETE1(_immediat       ,_nb_inst);
+      DELETE1(_read_ra        ,_nb_inst);
+      DELETE1(_num_reg_ra     ,_nb_inst);
+      DELETE1(_read_rb        ,_nb_inst);
+      DELETE1(_num_reg_rb     ,_nb_inst);
+      DELETE1(_read_rc        ,_nb_inst);
+      DELETE1(_num_reg_rc     ,_nb_inst);
+      DELETE1(_write_rd       ,_nb_inst);
+      DELETE1(_num_reg_rd     ,_nb_inst);
+      DELETE1(_write_re       ,_nb_inst);
+      DELETE1(_num_reg_re     ,_nb_inst);
+      DELETE1(_exception_use  ,_nb_inst);
+      DELETE1(_exception      ,_nb_inst);
     }
   };
